Bug 504726 (CVE-2009-1389) - CVE-2009-1389 kernel: r8169: fix crash when large packets are received
Summary: CVE-2009-1389 kernel: r8169: fix crash when large packets are received
Keywords:
Status: CLOSED ERRATA
Alias: CVE-2009-1389
Product: Security Response
Classification: Other
Component: vulnerability
Version: unspecified
Hardware: All
OS: Linux
high
high
Target Milestone: ---
Assignee: Red Hat Product Security
QA Contact:
URL:
Whiteboard:
Depends On: 504727 504728 504729 504730 504731 504732 518224 520007
Blocks:
TreeView+ depends on / blocked
 
Reported: 2009-06-09 02:43 UTC by Eugene Teo (Security Response)
Modified: 2019-09-29 12:30 UTC (History)
10 users (show)

Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2016-06-10 22:29:51 UTC


Attachments (Terms of Use)
backtraces (86.98 KB, image/jpeg)
2009-06-09 02:43 UTC, Eugene Teo (Security Response)
no flags Details


Links
System ID Priority Status Summary Last Updated
Red Hat Product Errata RHSA-2009:1157 normal SHIPPED_LIVE Important: kernel-rt security and bug fix update 2009-07-14 19:11:05 UTC
Red Hat Product Errata RHSA-2009:1193 normal SHIPPED_LIVE Important: kernel security and bug fix update 2009-08-04 13:15:15 UTC
Red Hat Product Errata RHSA-2009:1211 normal SHIPPED_LIVE Important: kernel security and bug fix update 2009-08-13 15:34:46 UTC
Red Hat Product Errata RHSA-2009:1457 normal SHIPPED_LIVE Important: kernel security update 2009-09-22 14:56:10 UTC
Red Hat Product Errata RHSA-2009:1469 normal SHIPPED_LIVE Important: kernel security update 2009-09-30 14:58:38 UTC

Description Eugene Teo (Security Response) 2009-06-09 02:43:13 UTC
Created attachment 346959 [details]
backtraces

Description of problem:
Michael Tokarev reported receiving a large packet could crash a machine with RTL8169 NIC.

Problem is this driver tells that NIC frames up to 16383 bytes can be received but provides skb to rx ring allocated with smaller sizes (1536 bytes in case standard 1500 bytes MTU is used)

When a frame larger than what was allocated by driver is received, dma transfert can occurs past the end of buffer and corrupt kernel memory.

Fix is to tell to NIC what is the maximum size a frame can be.

References:
http://marc.info/?t=123462473200002
http://lkml.org/lkml/2009/6/8/194
http://www.corpit.ru/mjt/r8169-mtu-oops.jpg
http://article.gmane.org/gmane.linux.network/130114
http://www.mail-archive.com/debian-kernel@lists.debian.org/msg45651.html

Comment 3 Eugene Teo (Security Response) 2009-06-09 03:14:32 UTC
Proposed patch:
http://thread.gmane.org/gmane.linux.network/130114

Comment 4 Eugene Teo (Security Response) 2009-06-10 05:23:18 UTC
(In reply to comment #3)
> Proposed patch:
> http://thread.gmane.org/gmane.linux.network/130114  

Upstream commit: http://git.kernel.org/linus/fdd7b4c3302c93f6833e338903ea77245eb510b4 (v2.6.30)

Comment 5 Fedora Update System 2009-06-18 22:08:08 UTC
kernel-2.6.27.25-78.2.56.fc9 has been submitted as an update for Fedora 9.
http://admin.fedoraproject.org/updates/kernel-2.6.27.25-78.2.56.fc9

Comment 6 Fedora Update System 2009-06-22 11:59:34 UTC
kernel-2.6.27.25-170.2.72.fc10 has been submitted as an update for Fedora 10.
http://admin.fedoraproject.org/updates/kernel-2.6.27.25-170.2.72.fc10

Comment 7 Fedora Update System 2009-06-24 19:18:07 UTC
kernel-2.6.27.25-170.2.72.fc10 has been pushed to the Fedora 10 stable repository.  If problems still persist, please make note of it in this bug report.

Comment 8 Fedora Update System 2009-06-24 19:23:09 UTC
kernel-2.6.29.5-191.fc11 has been pushed to the Fedora 11 stable repository.  If problems still persist, please make note of it in this bug report.

Comment 9 Fedora Update System 2009-06-24 19:35:29 UTC
kernel-2.6.27.25-78.2.56.fc9 has been pushed to the Fedora 9 stable repository.  If problems still persist, please make note of it in this bug report.

Comment 10 Manfred Knick 2009-06-25 11:04:02 UTC
(In reply to comment #8)

> kernel-2.6.29.5-191.fc11 has been pushed to the Fedora 11 stable repository. 
> If problems still persist, please make note of it in this bug report.  

  Yes; reported at:

  https://bugzilla.redhat.com/show_bug.cgi?id=460747#c99

Comment 11 Eugene Teo (Security Response) 2009-06-25 12:19:23 UTC
(In reply to comment #10)
> (In reply to comment #8)
> 
> > kernel-2.6.29.5-191.fc11 has been pushed to the Fedora 11 stable repository. 
> > If problems still persist, please make note of it in this bug report.  
> 
>   Yes; reported at:
> 
>   https://bugzilla.redhat.com/show_bug.cgi?id=460747#c99  

Manfred, it looks like a different problem as reported in bug 460747. Thanks.

Comment 12 Manfred Knick 2009-06-25 13:08:08 UTC
(In reply to comment #11)
> (In reply to comment #10)
> > (In reply to comment #8)

> .. looks like a different problem as reported in bug 460747 ...

Sure; just meant as a cross-reference.

From the diversity of bug reports in all the smitten kernel and distro's reporting systems, I've got the impression that R. have ejected quite a diversity of HW/FW (en detail) under the same-looking label ;)

Comment 13 errata-xmlrpc 2009-07-14 19:11:16 UTC
This issue has been addressed in following products:

  MRG for RHEL-5

Via RHSA-2009:1157 https://rhn.redhat.com/errata/RHSA-2009-1157.html

Comment 15 errata-xmlrpc 2009-08-04 13:15:30 UTC
This issue has been addressed in following products:

  Red Hat Enterprise Linux 5

Via RHSA-2009:1193 https://rhn.redhat.com/errata/RHSA-2009-1193.html

Comment 16 errata-xmlrpc 2009-08-13 15:35:05 UTC
This issue has been addressed in following products:

  Red Hat Enterprise Linux 4

Via RHSA-2009:1211 https://rhn.redhat.com/errata/RHSA-2009-1211.html

Comment 18 errata-xmlrpc 2009-09-22 14:57:51 UTC
This issue has been addressed in following products:

  Red Hat Enterprise Linux 5.2 Z Stream

Via RHSA-2009:1457 https://rhn.redhat.com/errata/RHSA-2009-1457.html

Comment 19 errata-xmlrpc 2009-09-30 14:58:41 UTC
This issue has been addressed in following products:

  Red Hat Enterprise Linux 4.7 Z Stream

Via RHSA-2009:1469 https://rhn.redhat.com/errata/RHSA-2009-1469.html


Note You need to log in before you can comment on or make changes to this bug.